/**CHeaderFile*****************************************************************

  FileName    [bmcPsl.h]

  PackageName [bmc]

  Synopsis    [Public interface for generating PSL SAT problems]

  Description []

  SeeAlso     []

  Author      [Timo Latvala]

  Copyright   [
  This file is part of the ``bmc'' package of NuSMV version 2.
  Copyright (C) 2000-2001 by ITC-irst and University of Trento.

  NuSMV version 2 is free software; you can redistribute it and/or
  modify it under the terms of the GNU Lesser General Public
  License as published by the Free Software Foundation; either
  version 2 of the License, or (at your option) any later version.

  NuSMV version 2 is distributed in the hope that it will be useful,
  but WITHOUT ANY WARRANTY; without even the implied warranty of
  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
  Lesser General Public License for more details.

  You should have received a copy of the GNU Lesser General Public
  License along with this library; if not, write to the Free Software
  Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA 02111-1307  USA.

  For more information of NuSMV see <http://nusmv.irst.itc.it>
  or email to <nusmv-users@irst.itc.it>.
  Please report bugs to <nusmv-users@irst.itc.it>.

  To contact the NuSMV development board, email to <nusmv@irst.itc.it>. ]

  Revision    [$Id: bmcCAV2006.h,v 1.1 2006/05/05 11:56:07 tjunttil Exp $]

******************************************************************************/

#ifndef _BMC_CAV2006__H
#define _BMC_CAV2006__H

#include "utils/utils.h"
#include "utils/str_assoc.h"
#include "prop/prop.h"
#include "sugar.h"
#include "bmcDump.h"

/*---------------------------------------------------------------------------*/
/* Constant declarations                                                     */
/*---------------------------------------------------------------------------*/

/*---------------------------------------------------------------------------*/
/* Type declarations                                                         */
/*---------------------------------------------------------------------------*/

/*---------------------------------------------------------------------------*/
/* Structure declarations                                                    */
/*---------------------------------------------------------------------------*/

/*---------------------------------------------------------------------------*/
/* Variable declarations                                                     */
/*---------------------------------------------------------------------------*/

/*---------------------------------------------------------------------------*/
/* Macro declarations                                                        */
/*---------------------------------------------------------------------------*/



/**AutomaticStart*************************************************************/

/*---------------------------------------------------------------------------*/
/* Function prototypes                                                       */
/*---------------------------------------------------------------------------*/

/* Either pslprop or waba (but not both) should be given */
EXTERN int 
Bmc_SolveCAV2006 (Prop_ptr pslprop,
		  Sugar_Automaton_t *given_waba,
		  str_hash_ptr given_waba_map_sugarap_to_ap,
		  const int k);

/**AutomaticEnd***************************************************************/

#endif /* _BMC_PSL__H */

