/**CHeaderFile*****************************************************************

  FileName    [bmcMH.h]

  PackageName [bmc]

  Synopsis    [Public interface for generating SAT problems by using Miyano-Hayashi]

  Description []

  SeeAlso     []

  Author      [Tommi Junttila]

  Copyright   [
  Copyright (C) 2006 Tommi Junttila, released under GNU LGPL ]

  Revision    [$Id: bmcMH.h,v 1.1 2006/05/05 11:56:07 tjunttil Exp $]

******************************************************************************/

#ifndef _BMC_MH__H
#define _BMC_MH__H

#include "utils/utils.h"
#include "utils/str_assoc.h"
#include "prop/prop.h"
#include "sugar.h"
#include "bmcDump.h"

/*---------------------------------------------------------------------------*/
/* Constant declarations                                                     */
/*---------------------------------------------------------------------------*/

/*---------------------------------------------------------------------------*/
/* Type declarations                                                         */
/*---------------------------------------------------------------------------*/

/*---------------------------------------------------------------------------*/
/* Structure declarations                                                    */
/*---------------------------------------------------------------------------*/

/*---------------------------------------------------------------------------*/
/* Variable declarations                                                     */
/*---------------------------------------------------------------------------*/

/*---------------------------------------------------------------------------*/
/* Macro declarations                                                        */
/*---------------------------------------------------------------------------*/



/**AutomaticStart*************************************************************/

/*---------------------------------------------------------------------------*/
/* Function prototypes                                                       */
/*---------------------------------------------------------------------------*/

/* Either pslprop or aba (but not both) should be given */
EXTERN int 
Bmc_SolveMH (Prop_ptr pslprop,
	     Sugar_Automaton_t *given_aba,
	     str_hash_ptr given_aba_map_sugarap_to_ap,
	     const int k);

/**AutomaticEnd***************************************************************/

#endif /* _BMC_MH__H */

