/**CHeaderFile*****************************************************************

  FileName    [bmcPsl.h]

  PackageName [bmc]

  Synopsis    [Public interface for generating PSL SAT problems by using Miyano-Hayashi]

  Description []

  SeeAlso     []

  Author      [TOmmi Junttila]

  Copyright   [
  Copyright (C) 2006 Tommi Junttila, released under GNU LGPL ]

  Revision    [$Id: bmcPslMH.h,v 1.1 2006/01/23 14:28:26 tjunttil Exp $]

******************************************************************************/

#ifndef _BMC_PSLMH__H
#define _BMC_PSLMH__H

#include "utils/utils.h"
#include "prop/prop.h"
#include "bmcDump.h"

/*---------------------------------------------------------------------------*/
/* Constant declarations                                                     */
/*---------------------------------------------------------------------------*/

/*---------------------------------------------------------------------------*/
/* Type declarations                                                         */
/*---------------------------------------------------------------------------*/

/*---------------------------------------------------------------------------*/
/* Structure declarations                                                    */
/*---------------------------------------------------------------------------*/

/*---------------------------------------------------------------------------*/
/* Variable declarations                                                     */
/*---------------------------------------------------------------------------*/

/*---------------------------------------------------------------------------*/
/* Macro declarations                                                        */
/*---------------------------------------------------------------------------*/



/**AutomaticStart*************************************************************/

/*---------------------------------------------------------------------------*/
/* Function prototypes                                                       */
/*---------------------------------------------------------------------------*/

EXTERN int 
Bmc_PslSolveMH (Prop_ptr ltlprop,
		const int k, const int relative_loop,
		const boolean must_inc_length,
		const boolean must_solve, 
		const Bmc_DumpType dump_type,
		const char* dump_fname_template); 

/**AutomaticEnd***************************************************************/

#endif /* _BMC_PSL__H */

